package com.example;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

public class Example {

    public static void main(String[] args) throws ExecutionException, InterruptedException, TimeoutException {
        CompletableFuture<Void> future = new CompletableFuture<>();
        NonBlockingThread thread = new NonBlockingThread(() -> {
            try {
                Thread.sleep(10);
                future.complete(null);
            }

            catch (Exception e) {
                // reactor.blockhound.BlockingOperationError should be thrown in case javaagent blockhound is used
                future.completeExceptionally(e);
            }
        });

        thread.start();
        // the following should throw reactor.blockhound.BlockingOperationError in case javaagent blockhound is used
        future.get(5, TimeUnit.SECONDS);
        
        // we should not run here in case javaagent blockhound is used
        System.out.println("Execution done without any errors.");
    }
}
