package com.example;

import org.assertj.core.api.Assertions;
import org.junit.jupiter.api.*;
import reactor.blockhound.BlockHound;
import reactor.blockhound.BlockingOperationError;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.TimeUnit;

public class BlockHoundTest {

    @Test
    void testBlockHound() {
        BlockHound.install(); // will use ExampleBlockHoundIntegration, see META_INF/services/reactor.blockhound.integration.BlockHoundIntegration

        CompletableFuture<Void> future = new CompletableFuture<>();
        NonBlockingThread thread = new NonBlockingThread(() -> {
            try {
                Thread.sleep(10);
            }

            catch (InterruptedException e) {
            }

            catch (BlockingOperationError e) {
                future.completeExceptionally(e);
            }
        });

        thread.start();

        Assertions.assertThatThrownBy(() -> future.get(5, TimeUnit.SECONDS))
                .hasCauseInstanceOf(BlockingOperationError.class);
    }

}
